#ifndef DISCRETIZATION_HELPER_THREE_HPP
#define DISCRETIZATION_HELPER_THREE_HPP

#include <medusa/Medusa_fwd.hpp>

using namespace mm;

template <typename Vec3d>
DomainDiscretization<Vec3d> build_3d_domain(const XML& conf, double dx) {
    HDF hdf("../data/duck_fill.h5", HDF::DESTROY);
    hdf.close();

    Range<NURBSPatch<Vec3d, Vec2d>> patches;

    // first patch
    {
        std::array<int, 2> p{3, 3};
        auto knots = std::array<Range<double>, 2>{
            Range<double>{-1.57079, -1.57079, -1.57079, -1.57079, -1.0472, -0.523599, 0.0, 0.523599,
                          0.808217, 1.04015, 1.0472, 1.24824, 1.29714, 1.46148, 1.57079, 1.57079,
                          1.57079, 1.57079},
            Range<double>{-3.14159, -3.14159, -3.14159, -3.14159, -2.61799, -2.0944, -1.0472,
                          -0.523599, 6.66134e-16, 0.523599, 1.0472, 2.0944, 2.61799, 3.14159,
                          3.14159, 3.14159, 3.14159}};

        double vals[546]{
            -3.88113,  -1.00949,  -21.0906,  -3.88113,  -1.00949,  -21.0906, -3.88113,  -1.00949,
            -21.0906,  -3.88113,  -1.00949,  -21.0906,  -3.88113,  -1.00949, -21.0906,  -3.88113,
            -1.00949,  -21.0906,  -3.88113,  -1.00949,  -21.0906,  -3.88113, -1.00949,  -21.0906,
            -3.88113,  -1.00949,  -21.0906,  -3.88113,  -1.00949,  -21.0906, -3.88113,  -1.00949,
            -21.0906,  -3.88113,  -1.00949,  -21.0906,  -3.88113,  -1.00949, -21.0906,  12.9366,
            -1.00949,  -21.0906,  12.9366,   0.303242,  -21.0906,  12.2939,  3.24194,   -21.0906,
            -0.851124, 7.79166,   -21.0906,  -6.91113,  7.8195,    -21.0906, -11.5925,  3.20018,
            -21.0906,  -12.5565,  -1.00949,  -21.0906,  -11.5925,  -5.21916, -21.0906,  -6.91113,
            -9.83849,  -21.0906,  -0.851124, -9.81065,  -21.0906,  12.2939,  -5.26093,  -21.0906,
            12.9366,   -2.32223,  -21.0906,  12.9366,   -1.00949,  -21.0906, 44.8852,   -1.00949,
            -20.3281,  44.8852,   3.14136,   -20.3281,  40.6928,   12.4338,  -20.3281,  8.24173,
            26.8202,   -20.3281,  -23.1085,  43.1006,   -20.3281,  -44.8761, 12.3017,   -20.3281,
            -51.1647,  -1.00949,  -20.3281,  -44.8761,  -14.3207,  -20.3281, -23.1085,  -45.1195,
            -20.3281,  8.24173,   -28.8392,  -20.3281,  40.6928,   -14.4528, -20.3281,  44.8852,
            -5.16034,  -20.3281,  44.8852,   -1.00949,  -20.3281,  72.3409,  -1.00949,  17.7258,
            72.3409,   6.12223,   17.7258,   57.8004,   43.7553,   17.7258,  36.0866,   35.6169,
            -3.60675,  -15.035,   55.95,     -2.58924,  -64.1096,  28.2646,  -2.58924,  -71.6869,
            -1.00949,  -2.58924,  -64.1096,  -30.2836,  -2.58924,  -15.035,  -57.969,   -2.58924,
            36.0866,   -37.6359,  -3.60675,  57.8004,   -45.7743,  17.7258,  72.3409,   -8.14122,
            17.7258,   72.3409,   -1.00949,  17.7258,   67.574,    -1.0095,  79.0407,   67.574,
            7.23905,   79.0407,   62.7688,   8.92462,   79.0406,   41.9426,  48.6277,   16.1266,
            -15.0519,  60.0161,   22.3107,   -65.2185,  32.8489,   20.8749,  -72.4263,  -1.00949,
            20.8749,   -65.2185,  -34.8679,  20.8749,   -15.0519,  -62.0351, 22.3107,   41.9426,
            -50.6467,  16.1266,   62.7688,   -10.9436,  79.0407,   67.574,   -9.25803,  79.0406,
            67.574,    -1.0095,   79.0407,   48.5835,   -1.00949,  56.6611,  48.5835,   0.968175,
            56.6611,   50.6656,   3.36527,   54.8281,   12.7023,   24.1247,  13.105,    -15.7584,
            48.0996,   33.5159,   -59.0226,  22.4058,   33.7453,   -64.5593, -1.00949,  33.7453,
            -59.0226,  -24.4248,  33.7453,   -15.7584,  -50.1186,  33.5159,  12.7023,   -25.1342,
            13.105,    50.6656,   -5.38426,  54.8281,   48.5835,   -2.98716, 56.6611,   48.5835,
            -1.00949,  56.6611,   37.0145,   -1.00949,  43.6649,   37.0145,  6.1256,    43.6649,
            32.6921,   22.8937,   41.2455,   16.3923,   30.0326,   35.7553,  -17.3625,  36.7184,
            38.6827,   -49.0038,  16.9792,   40.6447,   -53.124,   -1.00949, 40.6447,   -49.0038,
            -18.9982,  40.6447,   -17.3625,  -38.7374,  38.6827,   16.3923,  -32.0516,  35.7553,
            32.6921,   -24.9127,  41.2455,   37.0145,   -8.14459,  43.6649,  37.0145,   -1.00949,
            43.6649,   7.33509,   -1.00949,  37.0327,   7.33509,   1.94944,  37.0327,   7.02457,
            8.72519,   37.3348,   -3.00386,  25.8853,   43.3824,   -18.4431, 29.2811,   42.8002,
            -41.4856,  13.4331,   44.501,    -44.7927,  -1.00949,  44.501,   -41.4856,  -15.4521,
            44.501,    -18.4431,  -31.3001,  42.8002,   -3.00386,  -27.9043, 43.3824,   7.02457,
            -10.7442,  37.3349,   7.33509,   -3.96842,  37.0327,   7.33509,  -1.00949,  37.0327,
            0.0718746, -1.00949,  49.8154,   0.0718746, 1.8294,    49.8154,  -0.836516, 8.24889,
            49.9432,   -8.7426,   21.0087,   47.583,    -21.5965,  22.4788,  46.3929,   -38.4159,
            10.1897,   50.0795,   -40.9803,  -1.00949,  50.0795,   -38.4159, -12.2087,  50.0795,
            -21.5965,  -24.4978,  46.3929,   -8.7426,   -23.0277,  47.5831,  -0.836517, -10.2679,
            49.9432,   0.0718756, -3.84838,  49.8154,   0.0718746, -1.00949, 49.8154,   -2.96944,
            -1.00949,  54.02,     -2.96944,  2.84522,   54.02,     -4.60821, 11.5077,   54.0859,
            -8.8192,   26.3737,   52.999,    -25.2736,  27.1826,   53.7335,  -41.6394,  12.4325,
            54.1045,   -44.7174,  -1.00949,  54.1045,   -41.6394,  -14.4515, 54.1045,   -25.2736,
            -29.2016,  53.7335,   -8.8192,   -28.3927,  52.999,    -4.60821, -13.5266,  54.0859,
            -2.96944,  -4.86421,  54.02,     -2.96944,  -1.00949,  54.02,    12.3157,   -1.0095,
            70.7309,   12.3157,   3.50519,   70.7309,   10.1575,   13.6188,  70.7446,   -9.3821,
            29.5805,   71.998,    -28.6548,  29.828,    72.1513,   -52.9782, 14.2958,   72.2288,
            -56.3449,  -1.0095,   72.2288,   -52.9782,  -16.3147,  72.2288,  -28.6548,  -31.847,
            72.1513,   -9.3821,   -31.5995,  71.998,    10.1575,   -15.6378, 70.7446,   12.3157,
            -5.52418,  70.7309,   12.3157,   -1.0095,   70.7309,   4.42304,  -1.0095,   95.3549,
            4.42304,   2.87192,   95.3549,   2.52297,   11.561,    95.3549,  -11.775,   25.0134,
            95.3549,   -28.61,    25.0957,   95.3549,   -40.9005,  15.4255,  95.3549,   -51.2533,
            -1.0095,   95.3549,   -40.9005,  -17.4445,  95.3549,   -28.61,   -27.1147,  95.3549,
            -11.775,   -27.0323,  95.3549,   2.52297,   -13.58,    95.3549,  4.42304,   -4.89091,
            95.3549,   4.42304,   -1.0095,   95.3549,   -19.6734,  -1.00949, 98.8627,   -19.6734,
            -0.735432, 98.8627,   -19.8075,  -0.121915, 98.8627,   -20.7849, 0.827938,  98.8627,
            -22.05,    0.833751,  98.8627,   -23.0274,  -0.130634, 98.8627,  -23.2286,  -1.00949,
            98.8627,   -23.0274,  -1.88836,  98.8627,   -22.05,    -2.85274, 98.8627,   -20.7849,
            -2.84693,  98.8627,   -19.8075,  -1.89707,  98.8627,   -19.6734, -1.28356,  98.8627,
            -19.6734,  -1.00949,  98.8627,   -21.4175,  -1.00949,  98.4922,  -21.4175,  -1.00949,
            98.4922,   -21.4175,  -1.00949,  98.4922,   -21.4175,  -1.00949, 98.4922,   -21.4175,
            -1.00949,  98.4922,   -21.4175,  -1.00949,  98.4922,   -21.4175, -1.00949,  98.4922,
            -21.4175,  -1.00949,  98.4922,   -21.4175,  -1.00949,  98.4922,  -21.4175,  -1.00949,
            98.4922,   -21.4175,  -1.00949,  98.4922,   -21.4175,  -1.00949, 98.4922,   -21.4175,
            -1.00949,  98.4922};
        double wals[182]{
            1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
            0.5, 1.0, 1.0, 1.0, 1.0, 1.0, 0.5, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,
            1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0};

        Range<Range<double>> ws;
        for (int i = 0; i < 14; i++) {
            ws.push_back({});
            for (int j = 0; j < 13; j++) {
                ws[i].push_back(wals[13 * i + j]);
            }
        }

        Range<Range<Vec3d>> cps;
        for (int i = 0; i < 14; i++) {
            cps.push_back({});
            for (int j = 0; j < 13; j++) {
                Vec3d pt;
                for (int k = 0; k < 3; k++) {
                    pt(k) = vals[13 * 3 * i + 3 * j + k] / 100.0;
                }
                cps[i].push_back(pt);
            }
        }

        NURBSPatch<Vec3d, Vec2d> patch(cps, ws, knots, p);
        patches.push_back(patch);
    }

    NURBSShape<Vec3d, Vec2d> duck_shape(patches);
    duck_shape.boundaryProximity(1e-11);

    // Fill boundary
    auto boundary_type = conf.get<int>("domain.type_boundary");
    DomainDiscretization<Vec3d> domain = duck_shape.discretizeBoundaryWithStep(dx, boundary_type);

    // Fill the remainder with scattered nodes.
    int seed = 16;
    GeneralFill<Vec3d> gf;
    gf.seed(seed);
    domain.fill(gf, dx);

    return domain;
}

#endif /* DISCRETIZATION_HELPER_THREE_HPP */
